package org.globus.transfer.reliable.service;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.globus.rft.generated.RFTOptionsType;

public class UserSubjectUtil {

    private static Log logger = LogFactory.getLog(
        UserSubjectUtil.class.getName());

    public static String getUserSubject(RFTOptionsType rftOptions) {

        String userSubject = null;
        if (rftOptions != null) {
            // try subjectName
            userSubject = rftOptions.getSubjectName();
            if (checkForNull(userSubject)) {
                if (logger.isDebugEnabled()) {
                    logger.debug("rftOptions.subjectName null.");
                }
                // try sourceSubjectName
                userSubject = rftOptions.getSourceSubjectName();
                if (checkForNull(userSubject)) {
                    if (logger.isDebugEnabled()) {
                        logger.debug("rftOptions.sourceSubjectName null.");
                    }
                    // try destinationSubjectName
                    userSubject = rftOptions.getDestinationSubjectName();
                    if (checkForNull(userSubject)) {
                        if (logger.isDebugEnabled()) {
                            logger.debug("rftOptions.destinationSubjectName null.");
                        }
                        userSubject = null;
                    }
                }
            }
        }
        if (logger.isDebugEnabled()) {
            logger.debug("Returning subject " + userSubject);
        }
        return userSubject;
    }
    
    public static String getSourceUserSubject(RFTOptionsType rftOptions) {

        String userSubject = null;
        if (rftOptions != null) {
            // try sourceSubjectName
            userSubject = rftOptions.getSourceSubjectName();
            if (checkForNull(userSubject)) {
                if (logger.isDebugEnabled()) {
                    logger.debug("rftOptions.sourceSubjectName null.");
                }
                // try subjectName
                userSubject = rftOptions.getSubjectName();
                if (checkForNull(userSubject)) {
                    if (logger.isDebugEnabled()) {
                        logger.debug("rftOptions.subjectName null.");
                    }
                    userSubject = null;
                }
            }
        }
        if (logger.isDebugEnabled()) {
            logger.debug("Returning subject " + userSubject);
        }
        return userSubject;
    }
    
    public static String getDestinationUserSubject(RFTOptionsType rftOptions) {

        String userSubject = null;
        if (rftOptions != null) {
            // try destinationSubjectName
            userSubject = rftOptions.getDestinationSubjectName();
            if (checkForNull(userSubject)) {
                if (logger.isDebugEnabled()) {
                    logger.debug("rftOptions.destinationSubjectName null.");
                }
                // try subjectName
                userSubject = rftOptions.getSubjectName();
                if (checkForNull(userSubject)) {
                    if (logger.isDebugEnabled()) {
                        logger.debug("rftOptions.subjectName null.");
                    }
                    userSubject = null;
                }
            }
        }
        if (logger.isDebugEnabled()) {
            logger.debug("Returning subject " + userSubject);
        }
        return userSubject;
    }
    
    /**
     * Check a user subject.
     * @param subject
     * @return true in case the subject is null, contains only of white-spaces
     *         or has the value "null"
     */
    public static boolean checkForNull(String subject) {
        
        if (subject == null || subject.trim().equals("") ||
            subject.trim().equals("null")) {
            return true;
        } else {
            return false;
        }
    }
}
