package org.globus.transfer.reliable.service.cache;

import java.io.IOException;
import java.util.Vector;
import org.globus.ftp.HostPort;
import org.globus.ftp.exception.ServerException;
import org.globus.transfer.reliable.service.exception.RftTransientException;
import org.ietf.jgss.GSSCredential;

public class MlsdConnectionImpl extends SingleConnectionImpl
{
    private static final int numberFDs = 2;
    private HostPort hostPort;

    /**
     * @param params
     * @param credential
     * @throws IOException If the constructor call to GridFTPClient fails.
     * @throws ServerException If the constructor call to GridFTPClient fails. 
     * @throws RftTransientException If any other GridFTP server interaction
     *                               error occurs.
     */
    public MlsdConnectionImpl(
           ConnectionParameter  params,
           GSSCredential        credential,
           String               subjectName)
    throws IOException, ServerException, RftTransientException
    {
        super(params, credential, subjectName);
        this.type = ConnectionManager.MLSD_CONNECTION;
        try {
            this.hostPort = this.setLocalPassive();
            this.setActive(this.hostPort);
        } catch (Exception e) {
            throw new RftTransientException(
                "SetLocalPassive failed connecting to " +
                this.getHost(),e);
        }
    }

    public Vector doMlsd(String file)
    throws RftTransientException
    {
        try {
            return this.mlsd(file);
        } catch (Exception e) {
        	throw new RftTransientException(
                "Executing mlsd on " + file +
                " failed on server " + this.getHost(), e);
        }
    }

    public int getNumberFDs()
    {
        return numberFDs;
    }
}
